'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

(function (ActionStatus) {
    ActionStatus["BUSY"] = "busy";
    ActionStatus["SUCCESS"] = "success";
    ActionStatus["FAILURE"] = "failure";
})(exports.ActionStatus || (exports.ActionStatus = {}));
var values = Object.values(exports.ActionStatus);
/* istanbul ignore next */
(function (ActionStatus) {
    function has(value) {
        return values.includes(value);
    }
    ActionStatus.has = has;
})(exports.ActionStatus || (exports.ActionStatus = {}));

var prepareChain = function (chain) { return typeof chain === 'function'
    ? function (payload) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = [payload];
                return [4 /*yield*/, chain(payload)];
            case 1: return [2 /*return*/, _a.concat([_b.sent()])];
        }
    }); }); }
    : function (payload) { return __awaiter(void 0, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = [payload];
                return [4 /*yield*/, chain];
            case 1: return [2 /*return*/, _a.concat([_b.sent()])];
        }
    }); }); }; };
var createDispatcher = function (store, next, extra, type) { return function (_a) {
    var payload = _a[0], chain = _a[1];
    if (chain) {
        if (chain instanceof Array) {
            for (var i = 0; i < chain.length; i++) {
                if (chain[i])
                    store.dispatch(chain[i]);
            }
        }
        else {
            store.dispatch(chain);
        }
    }
    return next(__assign(__assign({}, extra), { payload: payload, type: type }));
}; };
var createErrorHandler = function (store, next, failureType, dispatchOnError, action, extra) { return function (error) {
    var payload = {
        error: error,
        origin: action,
    };
    var nextval = next(__assign(__assign({}, extra), { type: failureType, error: true, payload: payload }));
    if (dispatchOnError) {
        if (typeof dispatchOnError === 'string') {
            store.dispatch({
                type: dispatchOnError,
                error: true,
                payload: payload,
            });
        }
        else {
            var errorAction = dispatchOnError(payload);
            if (errorAction)
                store.dispatch(errorAction);
        }
    }
    return nextval;
}; };
var createPromiseResolver = function (store) { return function (next, promise, action, successType, failureType, chain, dispatchOnError, extra) { return promise
    .then(prepareChain(chain))
    .then(createDispatcher(store, next, extra, successType))
    .catch(createErrorHandler(store, next, failureType, dispatchOnError, action, extra)); }; };

var HOP = Object.prototype.hasOwnProperty;
var createMiddleware = function (store, next, resolve) { return function (action) {
    if (!HOP.call(action, 'promise')) {
        if (typeof action.transform !== 'function')
            return next(action);
        return next(action.transform(action, store.getState()));
    }
    var type = action.type, error = action.error, payload = action.payload, promise = action.promise, statusSelector = action.statusSelector, chain = action.chain, dispatchOnError = action.dispatchOnError, transform = action.transform, extra = __rest(action, ["type", "error", "payload", "promise", "statusSelector", "chain", "dispatchOnError", "transform"]);
    if (action.error === true)
        return next(action);
    if (statusSelector) { // Blocking  action
        if (!(type instanceof Array)) {
            throw new Error('`type` must be Array if `statusSelector` is defined');
        }
        var state = store.getState();
        if (!(statusSelector instanceof Array)) { // Single status selector
            var currentStatus = statusSelector(state);
            if (currentStatus === exports.ActionStatus.BUSY || currentStatus === false) {
                return null;
            }
        }
        else { // Block action if any status selector returns BUSY
            for (var i = 0; i < statusSelector.length; i++) {
                var currentStatus = statusSelector[i](state);
                if (currentStatus === exports.ActionStatus.BUSY || currentStatus === false) {
                    return null;
                }
            }
        }
    }
    // If action.transform function is set, apply it before passing action to next.
    var _next = typeof transform === 'function'
        ? (function (action) { return next(transform(action, store.getState())); })
        : next;
    var successType;
    var failureType;
    if (type instanceof Array) {
        _next(__assign({ type: type[0], payload: payload }, extra)); // Dispatch start action
        successType = type[1];
        failureType = type[2];
    }
    else {
        successType = failureType = type;
    }
    // At this point, start action has been reduced and status has been updated if necessary
    var _promise = typeof promise === 'function' ? promise() : promise;
    return resolve(_next, _promise, action, successType, failureType, chain, dispatchOnError, extra);
}; };
var middleware = function (store) { return function (next) {
    return createMiddleware(store, next, createPromiseResolver(store));
}; };

var createThunklessAction = function (action) { return action; };

exports.createThunklessAction = createThunklessAction;
exports.middleware = middleware;
